#!/bin/sh

# build <sophos> subdir getting files from given directory
# changing '#include "blah"' to '#include <sophos/blah>"
# usage example:
# 
#   cd ~mydir
#   gtar -xvzf savidtk.tar.gz
#   cd avfilter
#   ../mksophos.sh ../savi_dtk myuid:mygid
#

# target file owner
file_owner="$2"

if [ "$1" = "" -o ! -d "$1" -o ! -d "$1/sav_if" ]; then
	echo "expected sophos AV interface development toolkit directory: $1"
	exit 1
fi

if [ -d sophos ]; then
	echo "deleting all in sophos"
	rm -r -f sophos
fi

mkdir sophos
# let there a copy of this, as makerel.sh also exists...
cp -p $0 sophos
echo "directory sophos created"

base="$1/sav_if"
sed_script='s|^\([ 	]*#[ 	]*include[ 	]*\)"\([a-zA-Z0-9._-]*\)"[ 	]*$|\1<sophos/\2>|'
include=`find "$base" -type f -print`
for i in $include; do
	file="sophos/`basename $i`"
	if [ -f "$file" ]; then
		echo "ERROR: $file already exists"
		mv $file "${file}-duplicate-name"
	else
		echo "copying $file"
	fi
	cat $i | sed  "$sed_script" > $file
	if [ -n "$file_owner" ]; then
		chown $file_owner $file
	fi
	chmod u=rw,go=r $file
	touch -r "$i" $file
done
exit 0
